#include <iostream>
#include <vector>
#include "histogram.h"

//std::vector<size_t>

bool
find_minmax(const std::vector<double> numbers, double& min, double& max)
{
    if(numbers.empty())
    {
        return false;
    }
    /*/double/*/ min = numbers[0];//поиск мин и макс
    /*/ double/*/ max = numbers[0];
    for (double x : numbers)
    {
        if (x < min)
        {
            min = x;
        }
        else if (x > max)
        {
            max = x;
        }
    }

    return true;
}

std::vector<size_t>
make_histogram(const std::vector<double> numbers, size_t bin_count)
{
    std::vector <size_t> bins(bin_count);
    double min, max;
    find_minmax(numbers, min, max);
    double bin_size = (max-min)/bin_count;//размер корзины

    for (size_t i = 0; i < numbers.size(); i++)//заполнение
    {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++)
        {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi))
            {
                bins[j]++;
                found = true;
            }
        }

        if (!found)
        {
            bins[bin_count - 1]++;
        }
    }
    return bins;
}
